SystemOrganization addCategory: #'Scaffolding-Seaside'!
SystemOrganization addCategory: #'Scaffolding-Base'!
SystemOrganization addCategory: #'Scaffolding-Test-Base'!

!MAContainer methodsFor: '*scaffolding-base-query' stamp: 'obi 05/12/2009 12:37'!
fieldDescriptions
	 ^self children select: [:desc | desc kind ~~ Collection]
! !

!MAContainer methodsFor: '*scaffolding-base-query' stamp: 'obi 05/12/2009 12:37'!
noneRelationDescriptions
	 ^self fieldDescriptions
! !

!MAContainer methodsFor: '*scaffolding-base-query' stamp: 'obi 05/12/2009 12:36'!
relationDescriptions
	 ^self children select: [:desc | desc kind ~~ Collection]
! !

MAContainer subclass: #SGContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGContainer class methodsFor: 'as yet unclassified' stamp: 'YanniChiu 9/29/2009 12:18'!
defaultComponentClasses
	^ Array with: SGContainerComponent! !

!MADescription methodsFor: '*scaffolding-base-method-creation' stamp: 'obi 05/05/2009 12:59'!
accessingMethods
	^#()! !

!MADescription methodsFor: '*scaffolding-base-method-creation' stamp: 'obi 05/05/2009 12:59'!
updatingMethods
	^#()! !

MACommandColumn subclass: #SGCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGCommandColumn methodsFor: 'rendering' stamp: 'obi 11/01/2008 05:10'!
renderCellFormContent: anObject on: html
	self commands
		do: [ :each |
			html submitButton
				callback: [ each key value: self report value: anObject];
				text: each value ]
		separatedBy: [ html space ]! !

!SGCommandColumn methodsFor: 'rendering' stamp: 'obi 11/01/2008 05:10'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			html anchor
				callback: [ each key value: self report value: anObject ];
				with: each value ]
		separatedBy: [ html space ]! !

TestCase subclass: #SGTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Test-Base'!

!SGTestCase methodsFor: 'private' stamp: 'YanniChiu 2/5/2010 15:30'!
classNamed: aName
	"^System myUserProfile objectNamed: aName"
	^SGPlatform current objectNamed: aName asSymbol inSymbolList: nil.! !

!SGTestCase methodsFor: 'private' stamp: 'YanniChiu 1/31/2010 00:23'!
createTestClass
	| aClass |
	aClass := SGModel subclass: #SGTestA instVarNames: #(name description counter).
	aClass descriptionAt: 3 put: (aClass integerDescriptionOn: #counter).
	"aClass add: (aClass integerDescriptionOn: #counter)."
	^aClass! !

!SGTestCase methodsFor: 'private' stamp: 'obi 11/07/2008 06:07'!
executeWithTestClass: aBlock
	[aBlock value: self createTestClass] ensure: [self removeTestClass]! !

!SGTestCase methodsFor: 'private' stamp: 'obi 10/28/2008 13:30'!
removeClass: aClass
	aClass isNil ifFalse: [
		aClass safelyDo: [:i | i discard].
		self assert: (SGSystem removeClassNamed: aClass name)].! !

!SGTestCase methodsFor: 'private' stamp: 'obi 10/28/2008 13:33'!
removeTestClass
	self removeClass: self testClass! !

!SGTestCase methodsFor: 'test-components' stamp: 'obi 10/28/2008 13:34'!
testAsComponent
	| newObject |
	self createTestClass.
	newObject := self testClass new.
	newObject asComponent.
	self removeTestClass! !

!SGTestCase methodsFor: 'private' stamp: 'obi 11/03/2008 13:54'!
testClass
	^self classNamed: #SGTestA! !

!SGTestCase methodsFor: 'test-descriptions' stamp: 'obi 10/28/2008 12:26'!
testDescription
	| aContainer |
	aContainer := SGModel description.
	self assert: (aContainer isKindOf: MAContainer).
	self assert: aContainer children isEmpty! !

SGTestCase subclass: #SGTestInstance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Test-Base'!

!SGTestInstance methodsFor: 'testing' stamp: 'obi 11/07/2008 06:52'!
testInstanceAttributeChange
	self executeWithTestClass:
		[:aClass | | newObject |
		newObject := aClass new.
		newObject name: 'Test'.
		newObject description: 'Description'.
		newObject counter: 10.
		self assert: (newObject name = 'Test').
		self assert: (newObject description = 'Description').
		self assert: (newObject counter = 10)]! !

!SGTestInstance methodsFor: 'testing' stamp: 'obi 11/07/2008 06:50'!
testInstanceAttributeInitialize
	self executeWithTestClass:
		[:aClass | | newObject |
		newObject := aClass new.
		self assert: (newObject name isNil).
		self assert: (newObject description isNil).
		self assert: (newObject counter = 0)]! !

!SGTestInstance methodsFor: 'testing' stamp: 'YanniChiu 1/31/2010 00:35'!
testInstanceCreating
	| anObject oldSize newSize|
	oldSize := SGModel allInstances size.
	anObject := SGModel new.
	
	self assert: (anObject isKindOf: SGModel).
	self assert: oldSize + 1 == SGModel allInstances size.
	anObject discard.
	Smalltalk garbageCollect.
	self assert: oldSize == SGModel allInstances size.! !

!SGTestInstance methodsFor: 'testing' stamp: 'YanniChiu 2/4/2010 23:16'!
testTwowayRelation
	"TODO - SGUser and SGGroup removed. Create separate test classes."
	"| aUser aUser2 aGroup |
	aUser := SGUser new.
	aUser loginName: 'TestUser_1'.
	aUser2 := SGUser new.
	aUser2 loginName: 'TestUser_2'.
	aGroup := SGGroup new.
	aGroup name: 'TestGroup'.
	aUser groupsAdd: aGroup.
	aGroup usersAdd: aUser2.
	self assert: aGroup users size = 2.
	self assert: aUser groups size = 1.
	self assert: aUser2 groups size = 1.
	aUser discard.
	self assert: aGroup users size = 1.
	aUser2 discard.
	self assert: aGroup users size = 0.
	aGroup discard"! !

SGTestCase subclass: #SGTestMigration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Test-Base'!

!SGTestMigration methodsFor: 'testing' stamp: 'YanniChiu 2/5/2010 15:31'!
testClassCreation
	| testClassName newClass newObject |
	testClassName := #SGTestA.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	self assert: newClass notNil.
	newObject := newClass new.
	newObject name: 'Test'; description: 'Description'.
	self assert: newObject name = 'Test'.
	self assert: newClass description notNil.
	self assert: (newClass attributeDescriptions size == 2).
	newClass safelyDo: [:i | i discard].
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGPlatform current objectNamed: testClassName) isNil.
	self assert: (SGSystem hasInstancesOf: testClassName) not.! !

!SGTestMigration methodsFor: 'testing' stamp: 'YanniChiu 2/5/2010 15:31'!
testClassRedefine
	| testClassName newClass newObject newObject2 |
	testClassName := #SGTestA.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	newClass comment: 'comment'.
	newClass attributeContainer.
	newObject := newClass new.
	newClass := SGModel subclass: testClassName instVarNames: #(name description label).
	self assert: newClass comment = 'comment'.
	self assert: (newClass attributeDescriptions size == 3).
	newObject2 := newClass new.
	newObject name: 'Test'; description: 'Description'; label: 'Label'.
	newObject2 name: 'Test2'; description: 'Description2'; label: 'Label2'.
	self assert: newClass meta keys notEmpty.
	self assert: newObject class = newObject2 class.
	self assert: newObject name = 'Test'.
	self assert: newObject2 name = 'Test2'.
	self assert: (SGPlatform current classHistoryOf: newObject2 class) size == 1.
	newClass safelyDo: [:i | i discard].
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGPlatform current objectNamed: testClassName) isNil.
	self assert: (SGSystem hasInstancesOf: testClassName) not.! !

!SGTestMigration methodsFor: 'testing' stamp: 'YanniChiu 2/5/2010 15:31'!
testClassRedefine2
	| testClassName newClass newObject newObject2 |
	testClassName := #SGTestA.
	newClass := SGModel subclass: testClassName instVarNames: #(name description label).
	newClass comment: 'comment'.
	newClass attributeContainer.
	newObject := newClass new.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	self assert: newClass comment = 'comment'.
	self assert: (newClass attributeDescriptions size == 2).
	newObject2 := newClass new.
	newObject name: 'Test'; description: 'Description'.
	newObject2 name: 'Test2'; description: 'Description2'.
	self assert: newClass meta keys notEmpty.
	self assert: newObject class = newObject2 class.
	self assert: newObject name = 'Test'.
	self assert: newObject2 name = 'Test2'.
	self assert: (SGPlatform current classHistoryOf: newObject2 class) size == 1.
	newClass safelyDo: [:i | i discard].
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGPlatform current objectNamed: testClassName) isNil.
	self deny: (SGSystem hasInstancesOf: testClassName).! !

!SGTestMigration methodsFor: 'testing' stamp: 'YanniChiu 2/5/2010 15:31'!
testSuperclassRedefine
	| testClassName testClassName2 newClass newClass2 newObject newObject2 |
	testClassName := #SGTestA.
	testClassName2 := #SGTestA1.
	newClass := SGModel subclass: testClassName instVarNames: #(name description).
	newObject := newClass new.
	newObject name: 'Test A'.
	newClass2 := newClass subclass: testClassName2 instVarNames: #(test1 test2).
	newObject := newClass2 new.
	newObject name: 'Test A1'.
	newClass := SGModel subclass: testClassName instVarNames: #(name).
	
	"reassign class"
	newClass2 := SGPlatform current objectNamed: testClassName2 asSymbol inSymbolList: nil.

	self assert: newClass2 allInstVarNames size == 3.
	newClass safelyDo: [:i | i discard].
	newClass2 safelyDo: [:i | i discard]. 
	self assert: (SGSystem removeClassNamed: testClassName2).
	self assert: (SGSystem removeClassNamed: testClassName).
	self assert: (SGPlatform current objectNamed: testClassName asSymbol inSymbolList: nil) isNil.
	self assert: (SGPlatform current objectNamed: testClassName2 asSymbol inSymbolList: nil) isNil.
	self assert: (SGSystem hasInstancesOf: testClassName) not.
	self assert: (SGSystem hasInstancesOf: testClassName2) not.! !

MASingleOptionDescription subclass: #SGSingleOptionDescription
	instanceVariableNames: 'displayStringSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGSingleOptionDescription methodsFor: 'accessing' stamp: 'obi 12/29/2008 12:03'!
displayStringSelector

   "Return the value of the instance variable 'displayStringSelector'."
   ^displayStringSelector
! !

!SGSingleOptionDescription methodsFor: 'updating' stamp: 'obi 12/29/2008 12:03'!
displayStringSelector: newValue

   "Modify the value of the instance variable 'displayStringSelector'."
   displayStringSelector := newValue
! !

!SGSingleOptionDescription methodsFor: 'initialization' stamp: 'obi 12/29/2008 12:07'!
initialize
	super initialize.
	displayStringSelector := #displayString! !

!SGSingleOptionDescription methodsFor: 'private' stamp: 'obi 12/29/2008 12:07'!
labelForOption: anObject
	^anObject perform: displayStringSelector! !

!SGSingleOptionDescription methodsFor: 'accessing' stamp: 'obi 12/29/2008 12:05'!
options
	^ options isNil
		ifTrue: [#()]
		ifFalse: [options value]! !

SequenceableCollection subclass: #SGTwowayRelation
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGTwowayRelation methodsFor: 'Adding' stamp: 'obi 04/14/2009 11:51'!
add: aModel withAttribute: aSymbol
	self add: (aModel perform: aSymbol)
	! !

!SGTwowayRelation methodsFor: 'printing' stamp: 'YanniChiu 2/4/2010 00:36'!
asString
	| result |
	result := String new.
	self targets do: [:each | result add: each asString] separatedBy: [result add: ', '].
	^result! !

!SGTwowayRelation methodsFor: 'accessing' stamp: 'obi 04/14/2009 12:14'!
firstTarget
	self size == 0 ifTrue: [^nil].
	^(self at: 1) model! !

!SGTwowayRelation methodsFor: 'Searching' stamp: 'obi 04/14/2009 12:23'!
includesTarget: anObject
	1 to: self size do: [:i |
		  (anObject == (self at: i) model) ifTrue: [^true] ].

	^false
! !

!SGTwowayRelation methodsFor: 'accessing' stamp: 'obi 04/14/2009 11:48'!
model

   "Return the value of the instance variable 'model'."
   ^model
! !

!SGTwowayRelation methodsFor: 'updating' stamp: 'obi 04/14/2009 11:48'!
model: newValue

   "Modify the value of the instance variable 'model'."
   model := newValue
! !

!SGTwowayRelation methodsFor: 'printing' stamp: 'obi 04/20/2009 11:46'!
printOn: aStream
	self targets printOn: aStream! !

!SGTwowayRelation methodsFor: 'Removing' stamp: 'obi 04/14/2009 11:54'!
remove: aModel withAttribute: aSymbol
	self remove: aModel withAttribute: aSymbol ifAbsent: [self errorNotFound: aModel]
	! !

!SGTwowayRelation methodsFor: 'Removing' stamp: 'obi 04/14/2009 11:53'!
remove: aModel withAttribute: aSymbol ifAbsent: aBlock
	self remove: (aModel perform: aSymbol) ifAbsent: aBlock
	! !

!SGTwowayRelation methodsFor: 'accessing' stamp: 'YanniChiu 2/4/2010 00:36'!
targets
	| result |
	result := OrderedCollection new.
	self targetsDo: [:each | result add: each].
	^result! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:26'!
targetsDetect: aBlock
	^self targetsDetect: aBlock ifNone: [^ self error: #assocErrNoElementsDetected args: nil "#[aBlock]"]
! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:25'!
targetsDetect: aBlock ifNone: exceptionBlock

	1 to: self size do: [ :i | (aBlock value: (self at: i) model) ifTrue: [^(self at: i) model]]. 
	^exceptionBlock value
! !

!SGTwowayRelation methodsFor: 'Enumerating' stamp: 'obi 04/14/2009 12:19'!
targetsDo: aBlock
	1 to: self size do: [:idx | aBlock value: (self at: idx) model]! !

Object subclass: #SGModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

SGModel class
	instanceVariableNames: 'Meta'!

!SGModel commentStamp: 'obi 12/28/2008 12:32' prior: 0!
Root class for all my model classes.
!

SGModel class
	instanceVariableNames: 'Meta'!

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/01/2008 10:33'!
<= aClass
	^name <= aClass name! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/05/2009 12:54'!
accessorFor: anAttribute
	self allAttributeDescriptions do: [:desc | | acc | (acc := desc accessor) readSelector == anAttribute ifTrue: [^acc]].
	^nil! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/16/2009 10:51'!
accessorForAttribute: anAttribute
	self attributeContainer children do: [:desc | | accessor | accessor := desc accessor. accessor readSelector == anAttribute ifTrue: [^accessor]].
	^nil! !

!SGModel class methodsFor: 'adding-removing' stamp: 'YanniChiu 2/4/2010 23:09'!
add: anObject
	"TODO - what's going on here?'"
	^anObject
! !

!SGModel class methodsFor: 'methods-creation' stamp: 'FirstnameLastname 9/22/2009 21:31'!
addClassesAccessorFor: aDescription on: sourceString
	| theClasses |
	theClasses := aDescription classes.
	theClasses isEmpty ifFalse: [
			| str |
			str := ReadWriteStream on: String new..
			str nextPutAll: '		classes: (OrderedCollection new add: '.
			theClasses do: [:cl | str nextPutAll: cl name asString] separatedBy: [str nextPutAll: '; add: '].
			str nextPutAll: '; yourself);'.
			sourceString nextPutAll: str]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 12:56'!
addDescription: anAttributeDescription
	^self attributeContainer add: anAttributeDescription! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'YanniChiu 9/17/2009 16:25'!
allAttributeDescriptions
	| allDescriptions |

	allDescriptions := OrderedCollection new.
	self mySuperClasses reverseDo: [:cl |
		allDescriptions addAll: cl attributeContainer children].
	allDescriptions addAll: self attributeContainer children.
	^allDescriptions! !

!SGModel class methodsFor: 'accessing' stamp: 'Author 9/22/2009 17:40'!
allClasses
	^self withAllSubclasses asSortedCollection: [:a : b | a name < b name]! !

!SGModel class methodsFor: 'accessing' stamp: 'FirstnameLastname 9/24/2009 16:30'!
allInstancesSorted
	"TODO:
	^self allInstances sortAscending: self keyAttribute"
	^self selectAll! !

!SGModel class methodsFor: 'accessing' stamp: 'Author 9/22/2009 17:40'!
allUserClasses
	^(self withAllSubclasses select: [:cl | cl isBasic not]) asSortedCollection: [:a : b | a name < b name]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/08/2008 05:28'!
allVisibleAttributeDescriptions
	^self allAttributeDescriptions select: [:each | each isVisible]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/08/2008 05:52'!
allVisibleReadAccessors
	^self allVisibleAttributeDescriptions collect: [:desc | desc accessor readSelector]! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 04/21/2009 11:22'!
any
	self do: [:each | ^each].
	^nil! !

!SGModel class methodsFor: 'private' stamp: 'YanniChiu 9/17/2009 23:56'!
asLabel: aSelector
	| aLabel |
	aLabel := aSelector copy asString.
	aLabel at: 1 put: aLabel first asUppercase.
	^aLabel
	
	! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 10/28/2008 12:42'!
attributeContainer
	^self metaAtKey: #attributeContainer ifAbsent: [self metaAtKey: #attributeContainer put: self descriptionContainer].! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 10/28/2008 12:55'!
attributeDescriptions
	| theDescriptions |
	theDescriptions := self attributeContainer children.
	theDescriptions isEmpty ifTrue: [theDescriptions := self createDefaultDescriptions].
	^theDescriptions! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'YanniChiu 9/17/2009 23:33'!
attributesAsString
	"| result |
	result := String new.
	self instVarNames do: [:aSymbol | result add: aSymbol asString] separatedBy: [result add: $;].
	^result
	"
	^self instVarNames joinUsing: $;
! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 12/17/2008 11:31'!
cacheDescriptionMethods
	"use this to cache manually defined or changed descriptions methods"
	| currentDescriptions theInstVars |
	currentDescriptions := self attributeDescriptions.
	theInstVars := self instVarNames.
	theInstVars do: [:aSymbol | | currentDescription |
		currentDescription := currentDescriptions detect: [:desc | desc accessor readSelector == aSymbol] ifNone: [].
		currentDescription isNil
			ifFalse: [| oldIndex newDescription |
					newDescription := self defaultDescriptionOn: aSymbol.
					newDescription isNil ifFalse: [
						oldIndex := self attributeContainer children indexOf: currentDescription.
						self descriptionAt: oldIndex put: newDescription ] ]
			ifTrue: [self addDescription: (self defaultDescriptionOn: aSymbol)]].
	^self attributeDescriptions
! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/02/2008 09:40'!
canCreateSubclass
	^true! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/01/2008 11:25'!
canDelete
	self subclasses isEmpty ifFalse: [ ^false ].
	(SGSystem hasInstancesOf: name) ifTrue: [^false].
	^true! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/02/2008 11:18'!
canEdit
	^self isBasic not! !

!SGModel class methodsFor: 'private' stamp: 'YanniChiu 9/17/2009 18:05'!
categories
	^self organization categories! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/07/2008 06:47'!
changeDescription: anAttributeDescription to: newAttributeDescription
	self removeDescription: anAttributeDescription.
	^self addDescription: newAttributeDescription! !

!SGModel class methodsFor: 'querying' stamp: 'FirstnameLastname 9/24/2009 16:30'!
collect: aBlock
	^self selectAll collect: aBlock! !

!SGModel class methodsFor: 'meta-accessing' stamp: 'YanniChiu 9/17/2009 23:08'!
comment: aText
	"| doc txt |
	doc := GsClassDocumentation newForClass: self.
	txt := (GsDocText new) details: aText.
	doc documentClassWith: txt.
	self description: doc."

	self classComment: aText asString stamp: '<Scaffolding>'! !

!SGModel class methodsFor: 'methods-creation' stamp: 'YanniChiu 2/5/2010 14:39'!
compileAccessingAndUpdatingMethodsForDescription: aDescription
	| sourceStringArray "mySymbolList" |
	"mySymbolList := System myUserProfile symbolList."
	sourceStringArray := aDescription accessingMethods.
	sourceStringArray do: [:sourceString |
			self 
				compileMethod: sourceString
				dictionaries: "mySymbolList" nil
				category: #'accessing'].
	sourceStringArray := aDescription updatingMethods.
	sourceStringArray do: [:sourceString |
				self 
					compileMethod: sourceString
					dictionaries: "mySymbolList" nil
					category: #'updating']
	
! !

!SGModel class methodsFor: 'methods-creation' stamp: 'YanniChiu 2/5/2010 15:21'!
compileAccessingMethodsFor: anArrayOfSymbols
"GemStone compatibility"
| newLine allVarNames varName |

varName := 'newValue'.
allVarNames := self allInstVarNames.
[allVarNames includes: varName] whileTrue: [
  varName := 'z' , varName.
].
newLine:= Character cr asString.
anArrayOfSymbols do:
    [ :var |
		self compile: (var , newLine ,
            '   "Return the value of the instance variable ''' , var ,
            '''."' , newLine , '   ^' , var , newLine)
			classified: 'accessing' notifying: nil.

		self compile: (var , ': ' , varName , newLine ,
            '   "Modify the value of the instance variable ''' , var ,
            '''."' , newLine , '   ' , var , ' := ' , varName , newLine)
			classified: 'accessing' notifying: nil.
	]
! !

!SGModel class methodsFor: 'methods-creation' stamp: 'obi 04/20/2009 11:10'!
compileDescriptionMethods
	self attributeDescriptions do: [:each | 
		self compileAccessingAndUpdatingMethodsForDescription: each.
		self compileMethodForDescription: each]! !

!SGModel class methodsFor: 'methods-creation' stamp: 'FirstnameLastname 9/23/2009 23:59'!
compileMethodForDescription: aDescription
	| sourceString |
	sourceString := ReadWriteStream on: String new.
	sourceString nextPutAll: 'description',(self asLabel: aDescription accessor readSelector); cr.
	sourceString nextPutAll: '	^', aDescription class name asString, ' new'; cr.
	sourceString nextPutAll: '		selectorAccessor: ''', aDescription accessor readSelector asString; nextPutAll: ''';'; cr.
	sourceString nextPutAll: '		cssClass: ''', aDescription kind name asString asLowercase; nextPutAll: ''';'; cr.
	aDescription properties keysAndValuesDo: [:each :aValue |
				self methodPartFor: aDescription selector: each value: aValue on: sourceString].
	(aDescription isKindOf: MARelationDescription)
		ifTrue: [self addClassesAccessorFor: aDescription on: sourceString.
				"add default: to fix a magritte bug" 
				sourceString cr.
				sourceString nextPutAll: '		default: OrderedCollection new;'.
				sourceString cr].
	(aDescription isKindOf: SGTwowayRelationDescription)
		ifTrue: [sourceString nextPutAll: '		targetSelector: #', aDescription targetSelector printString; cr.].
	sourceString nextPutAll: '		yourself'.
	^self class
			compile: sourceString contents
			classified: 'accessing-description' notifying: nil.
	! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 13:19'!
createDefaultDescriptions
	self instVarNames do: [:aSymbol |
			self addDescription: (self defaultDescriptionOn: aSymbol)].
	^self attributeContainer children! !

!SGModel class methodsFor: 'migrating' stamp: 'YanniChiu 9/17/2009 23:58'!
createSubclass: aString instVarNames: anArrayOfStrings inDictionary: symbolDict
	^self subclass: aString asSymbol
	instanceVariableNames: anArrayOfStrings
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Generated Classes'
	
	" ^self subclass: aString
		instVarNames: anArrayOfStrings
		classVars: #()
		classInstVars: #()
		poolDictionaries: #[]
		category: 'Generated Classes'
		inDictionary: symbolDict
		constraints: #[]
		instancesInvariant: false
		isModifiable: false"! !

!SGModel class methodsFor: 'migrating' stamp: 'YanniChiu 2/5/2010 14:38'!
createUserSubclass: aString instVarNames: anArrayOfStrings
 	"| symbolDict |
	symbolDict := System myUserProfile symbolList objectNamed: #UserGlobals."
	^self createSubclass: aString instVarNames: anArrayOfStrings inDictionary: "symbolDict" nil! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/04/2008 11:58'!
defaultBatchSize
	^20! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'YanniChiu 2/4/2010 20:01'!
defaultCommandColumn
	^SGCommandColumn new
			addCommand: [:comp :model | comp call: model open ] text: 'Open';
			addCommand: [:comp :model | 
				"(comp lightbox: 
						(WAYesOrNoDialog new
							addMessage: 'Delete object: ', model displayString;
							yourself)) "
				(comp confirm: ('Delete object: ', model displayString))
						ifTrue: ["comp cache remove: model." model discard. comp answer: true] ] text: 'Discard';
			yourself! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/11/2008 13:31'!
defaultCssFor: aDescription
	^aDescription kind name asString! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/31/2008 10:58'!
defaultDescriptionOn: aSelector
	| descSelector |
	descSelector := ('description',(self asLabel: aSelector)) asSymbol.
	^(self respondsTo: descSelector)
		ifTrue: [self perform: descSelector]
		ifFalse: [self stringDescriptionOn: aSelector]! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/04/2008 14:21'!
defaultEditActions
	^#()! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/05/2008 16:55'!
defaultListActions
	^Array with: #newEditWithTitle -> 'New'! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/08/2008 05:38'!
defaultOpenAction
	^#openWithTitle! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 10/31/2008 15:09'!
defaultReport
	^self defaultReportOn: self allInstancesSorted! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/05/2008 15:56'!
defaultReportOn: instances
	^self defaultReportOn: instances commands:  self defaultCommandColumn
! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 05/12/2009 12:38'!
defaultReportOn: instances commands: commandColumn
	| report |
	report := MAReport new
				rowPeriod: 1;
				rows: instances;
				batchSize: self defaultBatchSize.
	self noneRelationDescriptions do: [:desc | report addColumnDescription: desc ].
	report addColumn: commandColumn.
	^report! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'obi 11/08/2008 05:38'!
defaultShowAction
	^#showWithTitle! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 12:23'!
description
	"use cached container"
	^self attributeContainer! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 12:17'!
descriptionAt: anIndex put: anAttributeDescription
	^self attributeContainer children at: anIndex put: anAttributeDescription! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'YanniChiu 9/29/2009 12:21'!
descriptionContainer
	"Return the default description container."

	^ SGContainer new
		label: self label;
		yourself! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/16/2009 10:49'!
descriptionForAttribute: anAttribute
	^self attributeContainer children detect: [:desc | desc accessor readSelector == anAttribute] ifNone: []! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 11:43'!
descriptionOn: aSelector type: aClass
	^aClass new
		cssClass: self name asString;
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'querying' stamp: 'obi 10/26/2008 01:01'!
detect: aBlock
	^self detect: aBlock ifNone: []! !

!SGModel class methodsFor: 'querying' stamp: 'FirstnameLastname 9/24/2009 16:30'!
detect: aBlock ifNone: otherBlock
	^self selectAll detect: aBlock ifNone: otherBlock! !

!SGModel class methodsFor: 'querying' stamp: 'FirstnameLastname 9/24/2009 16:31'!
do: aBlock
	^self selectAll do: aBlock! !

!SGModel class methodsFor: 'public' stamp: 'obi 11/01/2008 10:27'!
edit
	^SGEditClassPage on: self! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/07/2008 14:36'!
editorClass
	^SGSystem classNamed: self editorClassSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/07/2008 14:36'!
editorClassSymbol
	^(name, 'EditorComponent') asSymbol! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/04/2008 12:14'!
fullDescription
	| newContainer |
	newContainer := self descriptionContainer.
	newContainer setChildren: self allAttributeDescriptions.
	^newContainer
	! !

!SGModel class methodsFor: 'initialization' stamp: 'obi 10/31/2008 11:33'!
initialize
	self withAllSubclassesDo: [:cl | cl isBasic ifTrue: [cl resetDescriptions]]! !

!SGModel class methodsFor: 'accessing' stamp: 'FirstnameLastname 9/24/2009 16:31'!
instancesSize
	^self selectAll size! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:33'!
integerDescriptionOn: aSelector
	^MANumberDescription new
		cssClass: 'number';
		label: (self asLabel: aSelector asString);
		priority: 1;
		default: 0;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'testing' stamp: 'obi 11/02/2008 11:18'!
isBasic
	^name == #SGModel ! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 10/31/2008 15:07'!
keyAttribute
	^self allInstVarNames first! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 05:04'!
listClass
	^SGSystem classNamed: self listClassSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 05:04'!
listClassSymbol
	^(name, 'ListComponent') asSymbol! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:32'!
memoDescriptionOn: aSelector
	^MAMemoDescription new
		cssClass: 'string';
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'accessing' stamp: 'YanniChiu 2/5/2010 15:29'!
meta
	Meta ifNil: [Meta := SGPlatform current symbolDictionaryClass new].
	^Meta! !

!SGModel class methodsFor: 'accessing' stamp: 'go 10/25/2008 10:33'!
meta: aMetaDict
	Meta := aMetaDict! !

!SGModel class methodsFor: 'meta-accessing' stamp: 'obi 10/28/2008 11:39'!
metaAtKey: aKey ifAbsent: aBlock
	^self meta at: aKey ifAbsent: aBlock! !

!SGModel class methodsFor: 'meta-accessing' stamp: 'obi 10/28/2008 12:42'!
metaAtKey: aKey put: anObject
	^self meta at: aKey put: anObject! !

!SGModel class methodsFor: 'methods-creation' stamp: 'FirstnameLastname 9/23/2009 23:59'!
methodPartFor: aDescription selector: aSelector value: aValue on: sourceString
	aValue isNil
			ifFalse: [
				((aValue isKindOf: Collection) not or: [aValue isKindOf: String])
					ifTrue: [sourceString nextPutAll: '		', aSelector asString,': ', aValue  printString; nextPutAll: ';'; cr]].! !

!SGModel class methodsFor: 'private' stamp: 'Author 9/22/2009 17:24'!
mySuperClasses

"Returns an Array of all superclasses up to SGModel"

| result currClass |
result:= OrderedCollection new.
(self name == #SGModel)
  ifTrue: [^ result]
  ifFalse: [
    currClass := self superclass.
    [ currClass == SGModel ] whileFalse: [
      result add: currClass.
      currClass := currClass superclass.
    ].
  ].
^result
! !

!SGModel class methodsFor: 'instance creation' stamp: 'obi 10/31/2008 15:28'!
new
	| newObject |
	newObject := super new.
	self add: newObject.
	^newObject! !

!SGModel class methodsFor: 'public' stamp: 'obi 11/04/2008 12:02'!
newEdit
	^self newOpen! !

!SGModel class methodsFor: 'public' stamp: 'obi 11/05/2008 16:57'!
newEditWithTitle
	^self new openWithTitle! !

!SGModel class methodsFor: 'public' stamp: 'obi 10/31/2008 15:41'!
newOpen
	^self new open! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/07/2008 13:43'!
noneBasicClasses
	^self allClasses select: [:cl | cl isBasic not]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 05/12/2009 12:38'!
noneRelationDescriptions
	^self allAttributeDescriptions select: [:desc | desc kind ~~ Collection]! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:31'!
passwordDescriptionOn: aSelector
	^MAPasswordDescription new
		cssClass: 'string';
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'accessing-actions' stamp: 'YanniChiu 2/4/2010 00:44'!
projectCommandColumn
	^SGCommandColumn new
			addCommand: [:comp :model | "WARenderLoop new" self call: model showWithTitle ] text: 'Show';
			addCommand: [:comp :model | "WARenderLoop new" self call: model openWithTitle ] text: 'Edit';
			addCommand: [:comp :model | 
				(comp lightbox: (WAYesOrNoDialog new
						addMessage: 'Delete object: ', model displayString;
						yourself) ) 
						ifTrue: [comp cache remove: model. model discard] ] text: 'Discard';
			yourself! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/05/2008 15:57'!
projectReport
	^self projectReportOn: self allInstancesSorted! !

!SGModel class methodsFor: 'accessing-report' stamp: 'obi 11/05/2008 15:58'!
projectReportOn: instances
	^self defaultReportOn: instances commands:  self projectCommandColumn
! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:33'!
relationDescriptionOn: aSelector
	^MAToManyRelationDescription new
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'adding-removing' stamp: 'YanniChiu 2/4/2010 23:08'!
remove: anObject
	anObject destroy.
	^anObject
! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/03/2008 12:03'!
removeAttributeContainer
	self meta removeKey: #attributeContainer ifAbsent: []! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 11:45'!
removeDescription: anAttributeDescription
	^self attributeContainer remove: anAttributeDescription! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/03/2008 12:04'!
resetDescriptions
	self removeAttributeContainer.
	self setDescriptions: OrderedCollection new.
	^self updateDescriptions
! !

!SGModel class methodsFor: 'querying' stamp: 'FirstnameLastname 9/24/2009 16:32'!
safelyDo: aBlock
	^self selectAll copy do: aBlock! !

!SGModel class methodsFor: 'querying' stamp: 'FirstnameLastname 9/24/2009 16:31'!
select: aBlock
	^self selectAll select: aBlock! !

!SGModel class methodsFor: 'accessing' stamp: 'YanniChiu 2/4/2010 23:07'!
selectAll
	^(SqsSearch for: self) findAll! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 10/28/2008 12:19'!
setDescriptions: descriptionColl
	self attributeContainer setChildren: descriptionColl! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'obi 11/11/2008 13:31'!
stringDescriptionOn: aSelector
	^MAStringDescription new
		cssClass: 'string';
		label: (self asLabel: aSelector asString);
		priority: 1;
		selectorAccessor: aSelector;
		yourself.
! !

!SGModel class methodsFor: 'migrating' stamp: 'obi 11/04/2008 10:57'!
subclass: aString instVarNames: anArrayOfStrings

	^SGSystem redefineClassNamed: aString with: [
		self createUserSubclass: aString instVarNames: anArrayOfStrings ].! !

!SGModel class methodsFor: 'attributes-accessing' stamp: 'YanniChiu 9/18/2009 14:29'!
updateDescriptions
	| currentDescriptions theInstVars |
	currentDescriptions := self attributeDescriptions.
	theInstVars := self instVarNames.
	theInstVars do: [:each |
		(currentDescriptions detect: [:desc | desc accessor readSelector == each asSymbol] ifNone: []) isNil
			ifTrue: [self addDescription: (self defaultDescriptionOn: each)]].
	currentDescriptions copy do: [:desc |
		(theInstVars includes: desc accessor readSelector)
			ifFalse: [self attributeContainer remove: desc] ].
	^self attributeDescriptions
! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:10'!
viewClass
	^SGSystem classNamed: self viewClassSymbol! !

!SGModel class methodsFor: 'accessing' stamp: 'obi 11/08/2008 01:10'!
viewClassSymbol
	^(name, 'ViewComponent') asSymbol! !

!SGModel methodsFor: 'accessing' stamp: 'obi 05/05/2009 12:56'!
accessorFor: anAttribute
	^self class accessorFor: anAttribute! !

!SGModel methodsFor: 'accessing' stamp: 'obi 01/02/2009 10:22'!
asComponent
	^ self class fullDescription asComponentOn: self! !

!SGModel methodsFor: 'printing' stamp: 'obi 12/29/2008 12:21'!
asString
	^self displayString! !

!SGModel methodsFor: 'accessing' stamp: 'obi 10/31/2008 11:43'!
attributeDescriptions
	^self class attributeDescriptions! !

!SGModel methodsFor: 'removing' stamp: 'obi 05/05/2009 12:44'!
basicDiscard
	self release.
	self class remove: self! !

!SGModel methodsFor: 'testing' stamp: 'obi 10/31/2008 15:34'!
canDiscard
	^true! !

!SGModel methodsFor: 'removing' stamp: 'obi 10/31/2008 15:41'!
discard
	self canDiscard
		ifTrue: [self basicDiscard]! !

!SGModel methodsFor: 'printing' stamp: 'obi 11/25/2008 14:20'!
displayName
	^(self instVarAt: 1) asString! !

!SGModel methodsFor: 'printing' stamp: 'obi 11/04/2008 11:56'!
displayString
	^(self instVarAt: 1) asString , ' (', self class name asString,')'! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 03/27/2009 11:18'!
initialize
	"some hacks to avoid using always the same collection"
	self class attributeDescriptions do: [:desc | 
		desc kind = Collection
			ifTrue: [desc accessor write: OrderedCollection new to: self ]
			ifFalse: [self initializeWith: desc accessor using: desc]].
	self postInitialize
	! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 11/07/2008 05:56'!
initializeWith: maAccessor using: aDescription
"only init nil values"
	(maAccessor canWrite: self)
		ifTrue: [ maAccessor write: aDescription default to: self ] 
	! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 05/17/2009 11:50'!
open
	^self asComponent addValidatedForm! !

!SGModel methodsFor: 'actions' stamp: 'obi 11/08/2008 10:37'!
openWithTitle
	^self class editorClass on: self! !

!SGModel methodsFor: 'post-actions' stamp: 'obi 11/07/2008 06:14'!
postActions
	"override in subclasses if you need some one"! !

!SGModel methodsFor: 'post-actions' stamp: 'obi 11/07/2008 06:15'!
postInitialize
	"override in subclasses if you need some one"! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 05/05/2009 12:45'!
release
	"release all instVars"
	self class allAttributeDescriptions do: [:desc | desc accessor write: nil to: self ].

	! !

!SGModel methodsFor: 'initialize-release' stamp: 'obi 11/07/2008 05:57'!
safeInitialize
"only init nil values"
	self class attributeDescriptions do: [:desc | | maAccessor |
			maAccessor := desc accessor.
			(self perform: maAccessor readSelector)
				isNil ifTrue: [self initializeWith: maAccessor using: desc] ]
	! !

!SGModel methodsFor: 'actions' stamp: 'obi 11/05/2008 16:07'!
show
	^self asComponent addValidatedSwitch! !

!SGModel methodsFor: 'actions' stamp: 'obi 11/08/2008 10:37'!
showWithTitle
	^ self class viewClass on: self
! !

SGModel subclass: #SGTreeModel
	instanceVariableNames: 'parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGTreeModel class methodsFor: 'descriptions' stamp: 'obi 11/01/2008 08:32'!
childClasses
	^self allSubclasses! !

!SGTreeModel class methodsFor: 'descriptions' stamp: 'obi 11/01/2008 08:31'!
descriptionChildren
	^ MAToManyRelationDescription new
		classes: self childClasses;
		accessor: #children;
		label: 'Children';
		default: OrderedCollection new;
		priority: 100;
		visible: false;
		beDefinitive;
		beOrdered;
		yourself! !

!SGTreeModel class methodsFor: 'descriptions' stamp: 'obi 11/01/2008 08:35'!
descriptionParent
	^ MAToOneRelationDescription new
		classes: self childClasses;
		accessor: #parent;
		label: 'Parent';
		default: nil;
		priority: 50;
		visible: false;
		yourself! !

!SGTreeModel class methodsFor: 'testing' stamp: 'obi 11/01/2008 11:03'!
isBasic
	^name == #SGTreeModel! !

!SGTreeModel methodsFor: 'public' stamp: 'obi 11/07/2008 07:17'!
allChildren
	| result |
	result := OrderedCollection new.
	self allChildrenInto: result.
	^result! !

!SGTreeModel methodsFor: 'public' stamp: 'obi 11/07/2008 07:16'!
allChildrenInto: aCollection
	aCollection addAll: children.
	children do: [:each | each allChildrenInto: aCollection]! !

!SGTreeModel methodsFor: 'removing' stamp: 'obi 11/07/2008 07:15'!
basicDiscard
	super basicDiscard.
	self children do: [:each | each basicDiscard].
	parent := nil.
	children size: 0! !

!SGTreeModel methodsFor: 'Accessing' stamp: 'obi 11/01/2008 08:29'!
children

   "Return the value of the instance variable 'children'."
   ^children
! !

!SGTreeModel methodsFor: 'Updating' stamp: 'obi 11/01/2008 08:29'!
children: newValue

   "Modify the value of the instance variable 'children'."
   children := newValue
! !

!SGTreeModel methodsFor: 'printing' stamp: 'obi 11/05/2008 10:00'!
displayString
	^(self instVarAt: 3) asString , ' (', self class name asString,')'! !

!SGTreeModel methodsFor: 'Accessing' stamp: 'obi 11/01/2008 08:29'!
parent

   "Return the value of the instance variable 'parent'."
   ^parent
! !

!SGTreeModel methodsFor: 'Updating' stamp: 'obi 11/01/2008 08:29'!
parent: newValue

   "Modify the value of the instance variable 'parent'."
   parent := newValue
! !

Object subclass: #SGObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

SGObject subclass: #SGCommand
	instanceVariableNames: 'callback onClick with'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGCommand methodsFor: 'Accessing' stamp: 'obi 10/26/2008 12:41'!
callback

   "Return the value of the instance variable 'callback'."
   ^callback
! !

!SGCommand methodsFor: 'Updating' stamp: 'obi 10/26/2008 12:41'!
callback: newValue

   "Modify the value of the instance variable 'callback'."
   callback := newValue
! !

!SGCommand methodsFor: 'Accessing' stamp: 'obi 10/26/2008 12:41'!
onClick

   "Return the value of the instance variable 'onClick'."
   ^onClick
! !

!SGCommand methodsFor: 'Updating' stamp: 'obi 10/26/2008 12:41'!
onClick: newValue

   "Modify the value of the instance variable 'onClick'."
   onClick := newValue
! !

!SGCommand methodsFor: 'Accessing' stamp: 'obi 10/26/2008 12:41'!
with

   "Return the value of the instance variable 'with'."
   ^with
! !

!SGCommand methodsFor: 'Updating' stamp: 'obi 10/26/2008 12:41'!
with: newValue

   "Modify the value of the instance variable 'with'."
   with := newValue
! !

SGObject subclass: #SGRenderableItem
	instanceVariableNames: 'label selected action component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

SGRenderableItem subclass: #SGMenuItem
	instanceVariableNames: 'subItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGMenuItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 15:12'!
label: aLabel
	^self on: nil label: aLabel! !

!SGMenuItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 15:11'!
on: anActionBlock label: aLabel
	^self new action: anActionBlock; label: aLabel; yourself! !

!SGMenuItem methodsFor: 'public' stamp: 'obi 10/30/2008 15:04'!
add: anItem
	subItems add: anItem! !

!SGMenuItem methodsFor: 'initialize-release' stamp: 'obi 10/30/2008 15:28'!
initialize
	super initialize.
	subItems := OrderedCollection new! !

!SGMenuItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
subItems

   "Return the value of the instance variable 'subItems'."
   ^subItems
! !

!SGMenuItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
subItems: newValue

   "Modify the value of the instance variable 'subItems'."
   subItems := newValue
! !

!SGRenderableItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 16:13'!
label: aLabel
	^self on: nil label: aLabel! !

!SGRenderableItem class methodsFor: 'instance creation' stamp: 'obi 10/30/2008 16:13'!
on: anActionBlock label: aLabel
	^self new action: anActionBlock; label: aLabel; yourself! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
action

   "Return the value of the instance variable 'action'."
   ^action
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
action: newValue

   "Modify the value of the instance variable 'action'."
   action := newValue
! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/31/2008 12:05'!
component
	component ifNil: [self execute].
 	^component
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
component: newValue

   "Modify the value of the instance variable 'component'."
   component := newValue
! !

!SGRenderableItem methodsFor: 'public' stamp: 'obi 10/31/2008 12:05'!
execute
	component := action value.
	^component
! !

!SGRenderableItem methodsFor: 'initialize-release' stamp: 'obi 10/30/2008 15:28'!
initialize
	super initialize.
	selected := false.! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
label

   "Return the value of the instance variable 'label'."
   ^label
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue
! !

!SGRenderableItem methodsFor: 'rendering' stamp: 'obi 10/30/2008 15:59'!
renderOn: html
	action ifNotNil: [
		html render: self component]! !

!SGRenderableItem methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:27'!
selected

   "Return the value of the instance variable 'selected'."
   ^selected
! !

!SGRenderableItem methodsFor: 'Updating' stamp: 'obi 10/30/2008 15:27'!
selected: newValue

   "Modify the value of the instance variable 'selected'."
   selected := newValue
! !

SGRenderableItem subclass: #SGToolbarItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

Object subclass: #SGPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

SGPlatform subclass: #SGPharoPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGPharoPlatform class methodsFor: 'as yet unclassified' stamp: 'YanniChiu 2/5/2010 15:24'!
classHistoryOf: aClassDescription
	^ Array with: aClassDescription! !

!SGPharoPlatform class methodsFor: 'as yet unclassified' stamp: 'YanniChiu 2/5/2010 14:57'!
objectNamed: aSymbol
	^self objectNamed: aSymbol inSymbolList: nil! !

!SGPharoPlatform class methodsFor: 'as yet unclassified' stamp: 'YanniChiu 2/5/2010 14:52'!
objectNamed: aSymbol inSymbolList: ignored
	"was like:  System myUserProfile symbolList objectNamed: aClassName asSymbol."
	^Smalltalk at: aSymbol ifAbsent: [nil]! !

!SGPharoPlatform class methodsFor: 'as yet unclassified' stamp: 'YanniChiu 2/5/2010 15:14'!
symbolDictionaryClass
	"^SymbolDictionary" "--GemStone--"
	^IdentityDictionary! !

!SGPlatform class methodsFor: 'as yet unclassified' stamp: 'YanniChiu 2/5/2010 15:29'!
current
	^SGPharoPlatform! !

Object subclass: #SGSystem
	instanceVariableNames: ''
	classVariableNames: 'Mandator Types Users'
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGSystem class methodsFor: 'accessing-types' stamp: 'obi 10/26/2008 12:25'!
addType: aType
	self types add: aType! !

!SGSystem class methodsFor: 'class utilities' stamp: 'YanniChiu 2/5/2010 15:29'!
classNamed: aName
	"^System myUserProfile symbolList objectNamed: aName"
	^SGPlatform current objectNamed: aName! !

!SGSystem class methodsFor: 'private-project' stamp: 'obi 11/08/2008 04:57'!
createComponentClassNamed: className superclass: aSuperClass
	| aClass |
	aClass := self classNamed: className.
	aClass isNil
		ifTrue: [
			aClass := aSuperClass subclass: className
				instVarNames: #()
				classVars: #()
				classInstVars: #()
				poolDictionaries: #[]
				inDictionary: ''
				category: self projectCategory].
	^aClass! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 11/04/2008 10:26'!
currentMandator: aMandator
	| aSession |
	aSession := WACurrentSession value.
	aSession isNil 
		ifTrue: [Mandator := aMandator]
		ifFalse: [aSession mandator: aMandator]! !

!SGSystem class methodsFor: 'class utilities' stamp: 'YanniChiu 2/4/2010 23:06'!
hasInstancesOf: className
	"Answer true if there are instances of the class - i.e. cannot delete the class"
	"SGMandator allDo: [:aMandator | (aMandator hasInstancesOf: className) ifTrue: [^true] ]."
	^false! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 10/29/2008 14:59'!
modelClasses
	^SGModel withAllSubclasses! !

!SGSystem class methodsFor: 'private-project' stamp: 'obi 11/04/2008 13:22'!
projectCategory
	^'GemStone-Project'! !

!SGSystem class methodsFor: 'migrating' stamp: 'YanniChiu 2/5/2010 15:30'!
redefineClassNamed: aClassName with: aBlock
	"after redefining the class migrate self and all subclasses do also a recompile of my accessors and my descriptions"
	"remove also the old class versions afterwards"
	| originalClass classOrganizer cls |
	originalClass := SGPlatform current objectNamed: aClassName asSymbol inSymbolList: nil.
	"originalClass ~~ nil 
		ifTrue: [ 
			""pre-create the classOrganizer, so that original subclasses are preserved.""
			classOrganizer := ClassOrganizer cachedOrganizer ]."
	cls := aBlock value.
	cls == nil
		ifTrue: [ ^nil ].
	
	"originalClass ~~ nil
		ifTrue: [
			cls 
				copyMethodsFrom: originalClass 
				dictionaries: GsSession currentSession symbolList.
			""copy meta data""
			 cls meta: originalClass meta.
			cls comment: originalClass comment.
			""force redefinition of existing subclasses""
			self redefineSubclassesOf: originalClass using: classOrganizer.
			self migrateInstancesWithSubclassesOf: cls.
			cls classHistory removeVersion: originalClass]."
	
	"create accessors by default, but delete old ones"
	(cls organization categories includes: #Accessing) ifTrue: [cls removeCategory: #Accessing].
	(cls organization categories includes: #Updating) ifTrue: [cls removeCategory: #Updating].
	cls updateDescriptions.
	cls compileAccessingMethodsFor: cls instVarNames.
	^cls! !

!SGSystem class methodsFor: 'class utilities' stamp: 'obi 11/01/2008 11:26'!
removeClassNamed: aClassName
	^self removeClassNamed: aClassName check: true! !

!SGSystem class methodsFor: 'class utilities' stamp: 'YanniChiu 2/5/2010 15:30'!
removeClassNamed: aClassName check: aBoolean
	"the class should not have any instances and no subclasses"
	| aClass |
	aClass := SGPlatform current objectNamed: aClassName asSymbol.
	aClass isNil 
		ifFalse: [
			aBoolean ifTrue: [aClass canDelete ifFalse: [^false]].
			aClass removeFromSystem.
			"SGMandator allDo: [:aMandator | aMandator removeClassNamed: aClassName]"].
	^true! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 11/04/2008 07:38'!
sessionStateNumber
	^25! !

!SGSystem class methodsFor: 'accessing' stamp: 'obi 10/26/2008 12:26'!
types
	Types isNil ifTrue: [Types := IdentityBag new].
	^Types! !

MAOneToManyComponent subclass: #SGTwowayRelationComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGTwowayRelationComponent class methodsFor: 'testing' stamp: 'obi 05/12/2009 10:59'!
isAbstract
	^ false! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 05/16/2009 11:21'!
add
	| newModel result |
	newModel := self selected new.
	result := self root call: newModel open.
	result isNil
		ifFalse: [self add: newModel; refresh]
		ifTrue: [newModel discard]! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 05/16/2009 10:55'!
add: anObject
	self description accessor add: anObject to: self model.
	"self refresh"! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 05/12/2009 12:41'!
buildCommands
	commands := MACommandColumn new setReport: self report.
	self description isDefinitive ifFalse: [
		commands
			addCommandOn: self selector: #edit: text: 'edit';
			addCommandOn: self selector: #remove: text: 'remove' ].
	^ commands! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 05/12/2009 12:37'!
buildReport
	| newReport |
	newReport := (MAReport rows: self value)
					sortEnabled: self description isOrdered not.
	self reference noneRelationDescriptions do: [:desc | newReport addColumnDescription: desc ].
	^newReport! !

!SGTwowayRelationComponent methodsFor: 'private' stamp: 'obi 05/12/2009 12:49'!
model
	^self memento model! !

!SGTwowayRelationComponent methodsFor: 'actions' stamp: 'obi 05/12/2009 12:49'!
remove: anObject
	self description accessor remove: anObject from: self model.
	self refresh! !

!SGTwowayRelationComponent methodsFor: 'rendering' stamp: 'obi 05/16/2009 11:22'!
renderEditorOn: html
	 self renderSelectListOn: html.
	self renderViewerOn: html.! !

WAComponent subclass: #SGComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

SGComponent subclass: #SGAdmin
	instanceVariableNames: 'toolbar navigation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGAdmin class methodsFor: 'testing' stamp: 'obi 11/25/2008 13:37'!
canBeRoot
	^true! !

!SGAdmin class methodsFor: 'initialization' stamp: 'YanniChiu 2/4/2010 00:53'!
initialize
	^(self registerAsApplication: 'scaffolding/admin')
		addLibrary: SGLibrary;
		"addLibrary: SULibrary;"
		"preferenceAt: #sessionClass put: SGSession;"
		yourself! !

!SGAdmin methodsFor: 'accessing' stamp: 'obi 10/30/2008 15:31'!
children
	^Array with: navigation with: toolbar! !

!SGAdmin methodsFor: 'private' stamp: 'YanniChiu 2/4/2010 22:30'!
classMenuBlock
	^[| nav menu1 |
	nav := SGNavigation new.
	menu1 := SGMenuItem label: 'Class Actions'.
	menu1 add: (SGMenuItem on: [SGClassOverview new] label: 'Show Classes').
	menu1 add: (SGMenuItem on: [SGCreateClassPage new] label: 'Create Class').
	menu1 add: (SGMenuItem on: [SGClassExplorer new] label: 'Class Tree').
	nav addItem: menu1.
	menu1 := SGMenuItem label: 'Instances'.
	menu1 add: (SGMenuItem on: [SGInstanceOverview new] label: 'Show Instances').
	nav addItem: menu1.
	nav]! !

!SGAdmin methodsFor: 'initialize' stamp: 'YanniChiu 2/4/2010 22:35'!
initialize
	| menu1 |
	super initialize.
	toolbar := SGToolbar new.
	toolbar add: self classMenuBlock label: 'Classes'.
	"toolbar add: self helpMenuBlock label: 'Help'."
	toolbar onChange: [:aComponent | navigation := aComponent].
	toolbar selectFirst
	! !

!SGAdmin methodsFor: 'rendering' stamp: 'obi 10/30/2008 16:19'!
renderBodyOn: html
	self renderNavigationOn: html! !

!SGAdmin methodsFor: 'rendering' stamp: 'YanniChiu 2/4/2010 22:33'!
renderBottomOn: html
	html div
		class: 'bottom';
		with: [
			html table: 
				[html tableRow: [
					html tableData align: 'left'; style: 'width:100%';
						with: [
							"html text: 'Users: ', SGSystem users size asString.
							html text: ' | '."
							html text: 'Classes: ', SGSystem modelClasses size asString.
							"html text: ' | '.
							html text: 'Mandators: ', SGSystem mandators size asString."
							].
					html tableData align: 'right';
						with: [html text: Date today printString].
						]]]! !

!SGAdmin methodsFor: 'rendering' stamp: 'obi 10/29/2008 14:48'!
renderContentOn: html
	html div
		class: 'container';
		with: [
			self renderTopOn: html.
			self renderToolbarOn: html.
			self renderBodyOn: html.
			self renderBottomOn: html]! !

!SGAdmin methodsFor: 'rendering' stamp: 'obi 10/31/2008 09:01'!
renderNavigationOn: html
	html render: navigation

				! !

!SGAdmin methodsFor: 'rendering' stamp: 'YanniChiu 2/4/2010 22:28'!
renderToolbarOn: html
	html render: toolbar
! !

!SGAdmin methodsFor: 'rendering' stamp: 'YanniChiu 2/4/2010 22:27'!
renderTopOn: html
	html div class: 'header';
		with: [
			html heading: 'Scaffolding'.
			html text: 'Using Seaside, Magritte, ...']! !

SGComponent subclass: #SGClassExplorer
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGClassExplorer class methodsFor: 'testing' stamp: 'obi 05/18/2009 13:44'!
canBeRoot
	^true! !

!SGClassExplorer methodsFor: 'private' stamp: 'obi 11/02/2008 11:27'!
buildTree
	^ WATree new
		root: SGModel;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		selectBlock: [:class | self call: class edit];
		yourself! !

!SGClassExplorer methodsFor: 'accessing' stamp: 'obi 11/02/2008 11:23'!
children
	^Array with: tree! !

!SGClassExplorer methodsFor: 'initialize-release' stamp: 'obi 11/02/2008 11:23'!
initialize
	super initialize.
	tree := self buildTree
	! !

!SGClassExplorer methodsFor: 'rendering' stamp: 'obi 11/02/2008 11:23'!
renderContentOn: html
	html heading level2; with: 'Class Tree'.
	html div class: 'tree';
		with: [ html render: tree ].! !

SGComponent subclass: #SGClassOverview
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGClassOverview class methodsFor: 'testing' stamp: 'obi 05/18/2009 13:34'!
canBeRoot
	^true! !

!SGClassOverview methodsFor: 'private' stamp: 'obi 11/04/2008 11:25'!
allClasses
	^SGModel withAllSubclasses asSortedCollection! !

!SGClassOverview methodsFor: 'private' stamp: 'YanniChiu 2/4/2010 21:12'!
buildTable
	| report |
	report := MAReport new
		rowPeriod: 1;
		batchSize: 25;
		rows: (self allClasses).
	report
		addColumn:
			(MAColumn new accessor: #yourself; label: 'Class';yourself);
		addColumn:
			(MAColumn new
				accessor: #instancesSize;
				label: '# Instances';
				yourself);
		addColumn: self commandColumn.
	^report! !

!SGClassOverview methodsFor: 'accessing' stamp: 'obi 11/01/2008 10:32'!
children
	^Array with: table! !

!SGClassOverview methodsFor: 'private' stamp: 'YanniChiu 2/4/2010 21:16'!
commandColumn
	^MAColumn new
				renderer: [:each :html | 
					each isBasic 
						ifTrue: [
							each canCreateSubclass
								ifFalse: [html space]
								ifTrue: [
									html anchor
										callback: [self newSubclass: each ];
										title: 'Create subclass';
										with: 'Create' ] ]
						ifFalse: [
							html anchor
								callback: [self edit: each ];
								title: 'Edit class';
								with: 'Edit'.
							html space.
							html anchor
								callback: [self newSubclass: each ];
								title: 'Create subclass';
								with: 'Create'  ]];
				label: 'Actions';
				yourself! !

!SGClassOverview methodsFor: 'actions' stamp: 'obi 11/01/2008 12:10'!
edit: aClass
	| result |
	result := self call: aClass edit.
	result == #delete ifTrue: [table cache remove: aClass]! !

!SGClassOverview methodsFor: 'initialize-release' stamp: 'obi 11/01/2008 10:31'!
initialize
	super initialize.
	table := self buildTable
	! !

!SGClassOverview methodsFor: 'actions' stamp: 'obi 11/02/2008 11:14'!
newSubclass: aClass
	| result |
	result := self call: (SGCreateClassPage on: aClass).
	result isBehavior ifTrue: [table cache add: result]! !

!SGClassOverview methodsFor: 'private' stamp: 'obi 11/04/2008 11:29'!
refresh
	table rows: self allClasses
! !

!SGClassOverview methodsFor: 'rendering' stamp: 'obi 05/18/2009 13:40'!
renderContentOn: html
	html heading level2; with: 'Class Administration'.
	html render: table! !

SGClassOverview subclass: #SGInstanceOverview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGInstanceOverview methodsFor: 'private' stamp: 'YanniChiu 2/4/2010 21:17'!
commandColumn
	^MAColumn new
				renderer: [:each :html | 
					each isBasic 
						ifTrue: [html anchor
									callback: [self listInstances: each ];
									title: 'List instances';
									with: 'List'.]
						ifFalse: [
							html anchor
									callback: [self listInstances: each ];
									title: 'List instances';
									with: 'List'.
							html space.
							html anchor
									callback: [self newInstance: each ];
									title: 'Create new instance';
									with: 'New' ] ];
				label: 'Actions';
				yourself! !

!SGInstanceOverview methodsFor: 'actions' stamp: 'obi 11/04/2008 11:39'!
listInstances: aClass
	self call: aClass defaultReport! !

!SGInstanceOverview methodsFor: 'actions' stamp: 'obi 11/04/2008 11:39'!
newInstance: aClass
	self call: aClass newEdit! !

!SGInstanceOverview methodsFor: 'rendering' stamp: 'obi 05/18/2009 13:53'!
renderContentOn: html
	html heading level2; with: 'Show Instances'.
	html render: table.
	! !

!SGComponent methodsFor: 'convenience' stamp: 'obi 11/08/2008 10:03'!
confirm: aString
	"use lightbox instead of the default call:"
	^self lightbox: (WAYesOrNoDialog new
						addMessage: aString;
						yourself)! !

!SGComponent methodsFor: 'convenience' stamp: 'obi 11/25/2008 14:12'!
inform: aString
	"use lightbox instead of the default call:"
	^self lightbox: (WAFormDialog new
		addMessage: aString;
		yourself)! !

!SGComponent methodsFor: 'convenience' stamp: 'DataCurator 11/10/2008 12:04'!
title

	^'Scaffolding for GemStone/S'.
! !

!SGComponent methodsFor: 'convenience' stamp: 'DataCurator 11/10/2008 12:05'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self title.
! !

SGComponent subclass: #SGEditPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

SGEditPage subclass: #SGChangeType
	instanceVariableNames: 'theClass description selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGChangeType class methodsFor: 'instance creation' stamp: 'obi 11/03/2008 11:35'!
on: theClass description: desc
	^self new theClass: theClass; description: desc; yourself! !

!SGChangeType methodsFor: 'Accessing' stamp: 'obi 11/03/2008 11:27'!
description

   "Return the value of the instance variable 'description'."
   ^description
! !

!SGChangeType methodsFor: 'Updating' stamp: 'obi 11/03/2008 11:39'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue.
	selection := description class
! !

!SGChangeType methodsFor: 'accessing-configuration' stamp: 'obi 04/19/2009 11:01'!
descriptionClasses
	^ OrderedCollection new
		add: MAStringDescription;
		add: MAMemoDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: MABooleanDescription;
		add: MASingleOptionDescription;
		add: MAMultipleOptionDescription;
		add: MAToOneRelationDescription;
		add: MAToManyRelationDescription;
		add: SGTwowayRelationDescription;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: MAColorDescription;
		add: MATokenDescription;
		add: MAFileDescription;
		add: MAClassDescription;
		add: MATableDescription;
		yourself! !

!SGChangeType methodsFor: 'rendering' stamp: 'obi 11/04/2008 11:17'!
renderFormOn: html
	html heading: 'Change type for attribute: ', description accessor readSelector.
	html select list: self descriptionClasses; labels: [:each | each label]; on: #selection of: self.
	html break! !

!SGChangeType methodsFor: 'actions' stamp: 'obi 12/17/2008 11:07'!
save
	| newDescription oldIndex |
	newDescription := theClass descriptionOn: description accessor readSelector type: selection.
	newDescription priority: description priority.
	newDescription readonly: description readonly.
	newDescription required: description required.
	newDescription group: description group.
	newDescription comment: description comment.
	"fix for Magritte 1:m relations"
	"if default is not set, the table in the magritte editor for such descriptions will fail"
	(newDescription isKindOf: MAToManyRelationDescription) ifTrue: [newDescription default: Array new].
	"end fix"
	(newDescription isKindOf: MAToManyRelationDescription) ifTrue: [newDescription classes: SGModel noneBasicClasses].
	oldIndex := theClass attributeContainer children indexOf: description.
	theClass descriptionAt: oldIndex put: newDescription.
	self answer: newDescription! !

!SGChangeType methodsFor: 'Accessing' stamp: 'obi 11/03/2008 11:36'!
selection

   "Return the value of the instance variable 'selection'."
   ^selection
! !

!SGChangeType methodsFor: 'Updating' stamp: 'obi 11/03/2008 11:36'!
selection: newValue

   "Modify the value of the instance variable 'selection'."
   selection := newValue
! !

!SGChangeType methodsFor: 'Accessing' stamp: 'obi 11/03/2008 11:27'!
theClass

   "Return the value of the instance variable 'theClass'."
   ^theClass
! !

!SGChangeType methodsFor: 'Updating' stamp: 'obi 11/03/2008 11:27'!
theClass: newValue

   "Modify the value of the instance variable 'theClass'."
   theClass := newValue
! !

SGEditPage subclass: #SGCreateClassPage
	instanceVariableNames: 'list selection name attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGCreateClassPage class methodsFor: 'instance creation' stamp: 'obi 11/02/2008 09:34'!
on: aSuperclass
	^self new selection: aSuperclass; yourself! !

!SGCreateClassPage methodsFor: 'private' stamp: 'YanniChiu 9/17/2009 17:37'!
attributesArray
	^attributes isEmpty
		ifTrue: [#()]
		ifFalse: [(attributes subStrings: ';') collect: [:str | str withBlanksTrimmed]]! !

!SGCreateClassPage methodsFor: 'initialize-release' stamp: 'obi 11/01/2008 05:28'!
initialize
	super initialize.
	list := SGModel withAllSubclasses! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 05:27'!
list
	^list! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 05:27'!
list: aCollection
	list := aCollection! !

!SGCreateClassPage methodsFor: 'rendering' stamp: 'obi 11/02/2008 11:16'!
renderFormOn: html
	html table: 
		[html tableRow: [
			html tableHeading: 'Superclass'.
			html tableData: [html select list: self list; on: #selection of: self].
		html tableRow: [
			html tableHeading: 'Name'.
			html tableData: [html textInput callback: [:value | name := value] ] ].
		html tableRow: [
			html tableHeading: 'Attributes'.
			html tableData: [html textArea callback: [:value | attributes := value] ] ] ] ]
	! !

!SGCreateClassPage methodsFor: 'actions' stamp: 'obi 11/05/2008 07:32'!
save
	| newClass |
	selection isNil ifFalse: [
		name isEmpty ifFalse: [
			newClass := selection subclass: name instVarNames: (self attributesArray).
			newClass isNil ifFalse: [self home; call: newClass edit.
									newClass := SGSystem classNamed: newClass name.
									self answer: newClass ] ] ]! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/02/2008 11:16'!
selection
	^selection! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/02/2008 09:39'!
selection: aClass
	selection := aClass! !

!SGCreateClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 05:47'!
title
	^'Create Subclass'! !

SGEditPage subclass: #SGEditClassPage
	instanceVariableNames: 'theClass classComment attributes descTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGEditClassPage class methodsFor: 'instance creation' stamp: 'obi 11/03/2008 10:45'!
on: aClass
	^self new theClass: aClass; yourself! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 09:42'!
attributes

   "Return the value of the instance variable 'attributes'."
   ^attributes
! !

!SGEditClassPage methodsFor: 'Updating' stamp: 'obi 11/01/2008 11:48'!
attributes: newValue

   "Modify the value of the instance variable 'attributes'."
	attributes := newValue.! !

!SGEditClassPage methodsFor: 'private' stamp: 'YanniChiu 9/18/2009 15:13'!
attributesArray
	^attributes isEmpty
		ifTrue: [#()]
		ifFalse: [(attributes subStrings: ';') collect: [:str | str withBlanksTrimmed]]! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 11:38'!
attributesChanged
   ^theClass attributesAsString ~= attributes
! !

!SGEditClassPage methodsFor: 'private' stamp: 'obi 11/03/2008 11:25'!
buildDescriptionTable
	descTable := MAReport
		rows: theClass attributeDescriptions
		description: (MAElementDescription description reject: [:desc | desc isKindOf: MAReferenceDescription]).
	descTable addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'Edit';
			addCommandOn: self selector: #changeType: text: 'Change';
			addCommandOn: self selector: #moveUp: text: '/\';
			addCommandOn: self selector: #moveDown: text: '\/';
			yourself).
	^descTable! !

!SGEditClassPage methodsFor: 'private' stamp: 'obi 11/03/2008 11:17'!
buildEditorFor: anObject titled: aString
	^ anObject asComponent
		addValidatedForm;
		addMessage: aString;
		yourself! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'YanniChiu 9/18/2009 15:10'!
buttons
	| array |
	array := OrderedCollection new.
	theClass canEdit ifTrue: [
			array add: #save -> 'Save'].
	theClass canCreateSubclass ifTrue: [array add: #create -> 'Create subclass'].
	theClass canEdit ifTrue: [
			array add: #delete -> 'Delete'].
	array add: #cancel -> 'Cancel'.
	^array! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/03/2008 11:55'!
changeType: aDescription
	self call: (SGChangeType on: theClass description: aDescription).
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 11/03/2008 11:08'!
children
	^Array with: descTable! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 09:42'!
classComment

   "Return the value of the instance variable 'classComment'."
   ^classComment
! !

!SGEditClassPage methodsFor: 'Updating' stamp: 'obi 11/01/2008 09:42'!
classComment: newValue

   "Modify the value of the instance variable 'classComment'."
   classComment := newValue
! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/02/2008 11:31'!
create
	theClass isNil ifFalse: [self call: (SGCreateClassPage on: theClass)]! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/01/2008 12:09'!
delete
	| result |
	theClass isNil ifFalse: [
		(self confirm: 'Really delete ', theClass name asString)
			ifTrue: [
				theClass canDelete ifFalse: [^self inform: 'Delete is not possible -> Class has instances!!'].
				SGSystem removeClassNamed: theClass name check: false.
				self answer: #delete]]! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 11/03/2008 10:59'!
descTable
	descTable ifNil: [self buildDescriptionTable].
	^descTable! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 01/06/2009 06:11'!
editDescription: aDescription
	(aDescription isKindOf: MARelationDescription)
		ifTrue: [
			self call: (SGRelationDescriptionEditor
				on: aDescription
				titled: 'Edit ' , aDescription class label)]
		ifFalse: [
			self call: (self
				buildEditorFor: aDescription
				titled: 'Edit ' , aDescription class label)].
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'initialize-release' stamp: 'obi 11/03/2008 10:46'!
initialize
	super initialize.
	! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/03/2008 11:57'!
moveDown: aDescription
	theClass description moveDown: aDescription.
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 11/03/2008 11:56'!
moveUp: aDescription
	theClass description moveUp: aDescription.
	self buildDescriptionTable! !

!SGEditClassPage methodsFor: 'rendering' stamp: 'obi 11/03/2008 11:00'!
renderFormOn: html
	html table: 
		[html tableRow: [
			html tableHeading: 'Superclass'.
			html tableData: [
				theClass name == #SGModel
					ifTrue: [html text: theClass superclass]
					ifFalse: [self renderLinkTo: theClass superclass on: html ] ] ].
		html tableRow: [
			html tableHeading: 'Name'.
			html tableData: [html text: theClass name] ].
		html tableRow: [
			html tableHeading: 'Comment'.
			html tableData: [html textArea columns: 60; on: #classComment of: self ] ].
		html tableRow: [
			html tableHeading: 'Attributes'.
			html tableData: [html textArea columns: 60; on: #attributes of: self ] ].
		html tableRow: [
			html tableHeading: 'Subclasses'.
			html tableData: [theClass subclasses
								do: [:cl | self renderLinkTo: cl on: html ]
								separatedBy: [html space] ] ].
		
		 ] .
		html heading level3; with: 'Attribute descriptions'.
		html render: self descTable
	! !

!SGEditClassPage methodsFor: 'rendering' stamp: 'obi 11/02/2008 11:39'!
renderLinkTo: aClass on: html
	html anchor
		callback: [self call: aClass edit];
		with: aClass name! !

!SGEditClassPage methodsFor: 'actions' stamp: 'obi 01/06/2009 05:03'!
save
	| result |
	theClass isNil ifFalse: [
		theClass comment: classComment.
		self attributesChanged
			ifTrue: [
				theClass := theClass superclass subclass: theClass name instVarNames: self attributesArray.
				self theClass: theClass ].
		theClass compileDescriptionMethods]! !

!SGEditClassPage methodsFor: 'Accessing' stamp: 'obi 11/01/2008 09:42'!
theClass

   "Return the value of the instance variable 'theClass'."
   ^theClass
! !

!SGEditClassPage methodsFor: 'Updating' stamp: 'obi 11/03/2008 10:59'!
theClass: newValue
	theClass := newValue.
	self attributes: theClass attributesAsString.
	self classComment: theClass comment.
	self buildDescriptionTable
! !

!SGEditClassPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 09:39'!
title
	^'Edit class description'! !

!SGEditPage class methodsFor: 'instance creation' stamp: 'obi 11/01/2008 09:35'!
title: aString
	^self new title: aString; yourself! !

!SGEditPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 11:28'!
buttons
	^Array with: #save -> 'Save' with: #cancel -> 'Cancel'! !

!SGEditPage methodsFor: 'actions' stamp: 'obi 11/01/2008 11:09'!
cancel
	self answer: false! !

!SGEditPage methodsFor: 'rendering' stamp: 'obi 11/01/2008 09:49'!
renderButtonsOn: html
	self buttons do: [:anAssoc | 
		html submitButton value: anAssoc value; callback: [self perform: anAssoc key].
		html space ].

	! !

!SGEditPage methodsFor: 'rendering' stamp: 'obi 11/01/2008 09:35'!
renderContentOn: html
	html heading: self title.
	html form: 
		[self renderFormOn: html.
		self renderButtonsOn: html]! !

!SGEditPage methodsFor: 'rendering' stamp: 'obi 11/01/2008 09:35'!
renderFormOn: html
	! !

!SGEditPage methodsFor: 'actions' stamp: 'obi 11/01/2008 11:09'!
save
	self answer: true! !

!SGEditPage methodsFor: 'accessing' stamp: 'obi 11/01/2008 09:35'!
title
	^''! !

SGEditPage subclass: #SGRelationDescriptionEditor
	instanceVariableNames: 'description label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGRelationDescriptionEditor class methodsFor: 'instance creation' stamp: 'obi 01/06/2009 05:25'!
on: aDescription titled: aString
	^self new description: aDescription; label: aString; yourself! !

!SGRelationDescriptionEditor methodsFor: 'private' stamp: 'obi 04/21/2009 12:57'!
booleanAttributes
	^#(#readonly #visible #required #sorted #ordered)! !

!SGRelationDescriptionEditor methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:24'!
description

   "Return the value of the instance variable 'description'."
   ^description
! !

!SGRelationDescriptionEditor methodsFor: 'updating' stamp: 'obi 01/06/2009 05:24'!
description: newValue

   "Modify the value of the instance variable 'description'."
   description := newValue
! !

!SGRelationDescriptionEditor methodsFor: 'private' stamp: 'obi 01/06/2009 05:40'!
descriptionFor: aSelector
	^description detect: [:desc | desc accessor readSelector = aSelector] ifNone: []! !

!SGRelationDescriptionEditor methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:24'!
label

   "Return the value of the instance variable 'label'."
   ^label
! !

!SGRelationDescriptionEditor methodsFor: 'updating' stamp: 'obi 01/06/2009 05:24'!
label: newValue

   "Modify the value of the instance variable 'label'."
   label := newValue
! !

!SGRelationDescriptionEditor methodsFor: 'rendering' stamp: 'obi 04/21/2009 12:56'!
renderCheckboxRowFor: aSelector on: html
	(description respondsTo: aSelector)
		ifTrue: [
			html tableRow: [
				html tableHeading: aSelector asString capitalized.
				html tableData: [html checkbox on: aSelector of: description] ] ].! !

!SGRelationDescriptionEditor methodsFor: 'rendering' stamp: 'obi 01/06/2009 06:07'!
renderFormOn: html
	html table: 
		[self stringAttributes do: [:aSelector | self renderRowFor: aSelector on: html].
		self booleanAttributes do: [:aSelector | self renderCheckboxRowFor: aSelector on: html].
		
		html tableRow: [
				html tableHeading: 'Classes'.
				html tableData: [
					html multiSelect
						list: SGModel allUserClasses;
						size: 10;
						selected: description classes;
						callback: [:value | description classes: value]]].

		
		 ] .

	! !

!SGRelationDescriptionEditor methodsFor: 'rendering' stamp: 'obi 04/21/2009 12:57'!
renderRowFor: aSelector on: html
	(description respondsTo: aSelector)
		ifTrue: [
			html tableRow: [
				html tableHeading: aSelector asString capitalized.
				html tableData: [html textInput on: aSelector of: description] ] ].! !

!SGRelationDescriptionEditor methodsFor: 'private' stamp: 'obi 04/21/2009 12:54'!
stringAttributes
	^#(#label #group #comment #priority #targetSelector)! !

!SGRelationDescriptionEditor methodsFor: 'accessing' stamp: 'obi 01/06/2009 05:26'!
title
	^self label! !

SGComponent subclass: #SGLogin
	instanceVariableNames: 'password project mandator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGLogin class methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:35'!
canBeRoot
	^true! !

!SGLogin class methodsFor: 'accessing' stamp: 'YanniChiu 2/4/2010 00:58'!
initialize
	^(self registerAsApplication: 'scaffolding/login')
		addLibrary: SGLibrary;
		"addLibrary: SULibrary;"
		"preferenceAt: #sessionClass put: SGSession;"
		yourself! !

!SGLogin methodsFor: 'actions' stamp: 'obi 11/25/2008 14:49'!
login
	| aUser aComponentClass |
	aUser := self session user.
	aUser isNil ifTrue: [^self inform: 'Unkown user - try again!!'].
	aUser password = password
		ifFalse: [^self inform: 'Invalid password - try again!!'].
		
	aComponentClass := project componentClass.
	aComponentClass isNil ifTrue: [^self inform: 'Component class "' , project componentClassName ,'" not found!!'].
	
	"set mandator which is used for this session"
	self session mandator: mandator.
	"open my application"
	self call: aComponentClass new
	
	
! !

!SGLogin methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:59'!
password
	^password! !

!SGLogin methodsFor: 'accessing' stamp: 'obi 11/25/2008 13:59'!
password: aString
	password := aString! !

!SGLogin methodsFor: 'rendering' stamp: 'YanniChiu 2/4/2010 22:48'!
renderContentOn: html

	html table
		style: 'width:100%';
		with: [
			html tableRow: [
			html tableData align: 'center'; with: [
				
			html div class: 'login rounded';
				with: [
				html heading: 'Scaffolding Login'.
				html break.
	
				html form: [
					html table: [
						html tableRow: [
							html tableHeading: 'User'.
							html tableData: ["html textInput on: #userName of: self session"]].
						
						html tableRow: [
							html tableHeading: 'Password'.
							html tableData: ["html passwordInput on: #password of: self"]].
						
						html tableRow: [
							html tableData
								align: 'center'; 
								colSpan: 99;
								with: [html break. html submitButton value: 'Login'; callback: [self login]]]]]]]]]! !

SGComponent subclass: #SGNavigation
	instanceVariableNames: 'items selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGNavigation methodsFor: 'public' stamp: 'obi 10/30/2008 16:14'!
add: anAction label: aLabel
	"Add anAction to the collection of child items. Answer an instance of SUNavigationItem."

	^ items add: (self navigationItemClass on: anAction label: aLabel)! !

!SGNavigation methodsFor: 'public' stamp: 'obi 10/30/2008 16:18'!
addItem: anItem
	items add: anItem! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/31/2008 11:58'!
children
	selection ifNil: [^#()].
	^Array with: selection component! !

!SGNavigation methodsFor: 'actions' stamp: 'obi 10/30/2008 15:48'!
execute: menuItem
	selection := menuItem.
	menuItem execute! !

!SGNavigation methodsFor: 'initialize-release' stamp: 'obi 10/30/2008 15:00'!
initialize
	super initialize.
	items := OrderedCollection new! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/30/2008 14:59'!
items
 ^items! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:00'!
navigationItemClass
	"Answer the navigation class to represent the child items."

	^ SGMenuItem! !

!SGNavigation methodsFor: 'rendering' stamp: 'obi 10/30/2008 15:53'!
renderContentOn: html
html table class: 'page';
		with: [
		html tableRow: [
			html tableData class: 'navigation';
				with: [self renderNavigationOn: html].
			
			html tableData class: 'contents';
				with: [html render: selection] ] ]

	! !

!SGNavigation methodsFor: 'rendering' stamp: 'obi 10/31/2008 08:55'!
renderNavigationOn: html
	
	items do: [:menuItem |
		menuItem action isNil
			ifTrue: [
				html div
					class: 'title';
					with: menuItem label]
			ifFalse: [html div
					class: 'title';
					with: [
				html anchor
					callback: [self selection: menuItem];
					with: menuItem label]].
		html div
			class: 'list';
			with: [menuItem subItems
						do: [:subMenu | 
							html div class: 'item';	
								with: [subMenu label
										isEmpty 
											ifTrue: [html break]
											ifFalse: [
												html anchor
													callback: [self selection: subMenu];
													with: subMenu label] ] ] ].
		menuItem subItems isEmpty ifFalse: [ html break ] ]
	 
! !

!SGNavigation methodsFor: 'public' stamp: 'obi 10/30/2008 16:30'!
selectFirst
	items isEmpty ifFalse: [self selection: items first]! !

!SGNavigation methodsFor: 'Accessing' stamp: 'obi 10/30/2008 15:49'!
selection
	^selection
	! !

!SGNavigation methodsFor: 'actions' stamp: 'obi 10/30/2008 15:54'!
selection: menuItem
	selection := menuItem.
	menuItem execute! !

SGNavigation subclass: #SGToolbar
	instanceVariableNames: 'onChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGToolbar methodsFor: 'accessing' stamp: 'obi 10/30/2008 16:05'!
navigationItemClass
	"Answer the navigation class to represent the child items."

	^ SGToolbarItem! !

!SGToolbar methodsFor: 'accessing' stamp: 'obi 10/30/2008 15:54'!
onChange: aBlock
	onChange := aBlock! !

!SGToolbar methodsFor: 'rendering' stamp: 'obi 10/30/2008 16:00'!
renderContentOn: html
	html div class: 'toolbar';
		with: [
			items do: [:menuItem |
				html anchor
					callback: [self selection: menuItem];
					with: menuItem label.
				 ] ]
	 
! !

!SGToolbar methodsFor: 'rendering' stamp: 'obi 10/30/2008 15:47'!
renderNavigationOn: html
	html div class: 'toolbar';
		with: [
			items do: [:menuItem |
				html anchor
					callback: [self selection: menuItem];
					with: menuItem label.
				 ] ]
	 
! !

!SGToolbar methodsFor: 'actions' stamp: 'obi 10/30/2008 16:01'!
selection: menuItem
	super selection.
	onChange ifNotNil: [onChange value: menuItem component]! !

WAFileLibrary subclass: #SGLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGLibrary methodsFor: 'other' stamp: 'obi 11/07/2008 13:57'!
adminCss
	^'
	body {margin: 0px;padding: 10px;border: 0px;background: gray;text-align: center;}
	body, div, tr, td, th, form input, form submit {font-family: verdana, Arial, Helvetica, sans-serif;font-size: 11px;}
	table, tr, td, th, form {margin: 0px;padding: 0px;border: 0px;}
	th {text-align: left;}
	a, a:visited {color: #000046;text-decoration: none;}
	.container {margin: auto;width: 980px;background: white ;border: 1px solid #24a;border-top: 5px solid #24a;border-bottom: 5px solid #24a;text-align: left;-moz-border-radius:5px;border-radius:5px}
	.top {width: 880px; height: 50px;background:#c5c4c3;border-bottom: 1px solid black;font-size: 9px;text-align: right;}
	.toolbar {height: 18px;border-bottom: 1px dotted black;border-top: 1px dotted black;background: white;}
	.toolbar a {padding-left: 10px;padding-right: 10px;padding-top: 3px;padding-bottom: 2px;margin-left: -1px;border-left: 1px solid black;border-right: 1px solid black;line-height: 18px;letter-spacing: 1px;text-decoration: none;}
	.toolbar a:hover {color: white;background-color: #000046;}
	.page {padding: 0px;width:100%}
	.header {padding-bottom:4px;padding-left:4px;background:#9cf}
	.page td,.page th {padding-right: 5px;vertical-align: top;}
	.page .navigation {width: 110px;padding: 6px;padding-top: 0px;border-right:1px dotted #ccc}
	.page .navigation .title {margin-top: 4px;font-weight: bold;}
	.page .contents {width: 830px;padding-left:6px;padding-top:4px; height: 600px;text-align: justify;overflow:auto}
	.page .contents a {color:#5588ff}
	.page .contents a:hover {text-decoration:underline}
	.page .contents td {padding:2px 1px}

	h1,h2,h3 {margin-top: 0px}
	h1 {margin-bottom: 2px;font-size: 24px;}
	h2 {margin-bottom: 1px;font-size: 15px;}
	h3 {margin-bottom: 1px;font-size: 13px;}
	.page h1 {margin-bottom: 3px;font-size: 15px;}
	.page h2 {margin-bottom: 2px;font-size: 12px;}
	.page h3 {margin-top: 4px;margin-bottom: 2px;font-size: 12px;}
	.tree ul {margin-left:6px;padding-left:8px}
	hr {border: none;border-bottom: 1px dotted black;}
	.bottom {padding-left: 5px;padding-right: 5px;margin: 0px;clear: both;border-top: 1px solid black;background: white}
	.bottom td {font-size:9px;white-space:nowrap}
	.TabSelected {background-color: #000046;color: white;width: 95px;text-align: center;}
	.TabUnselected {background-color: #C3C3D3;width: 95px;text-align: center}
	.TabSpacer {width: 5px;}.TabLine {background-color: #000046;}
	.batch {text-align: center;margin-top: 8px;}
	.even {background-color: #E1E1E9;}
	.odd {}
	div#lightbox {padding:6px;border:1px solid blue;background:#e0e0e0;-moz-border-radius: 10px;-webkit-border-radius:10px;border-radius:10px;text-decoration:none}
	body div#overlay {
	z-index: 9998;
	background-color: #369;
	filter: alpha(opacity=30);
	-moz-opacity: 0.3;
	opacity: 0.3}'
! !

!SGLibrary methodsFor: 'other' stamp: 'obi 10/31/2008 13:20'!
magritteCss
	^'ul.errors {background:#f88;padding-left:16px;border:1px dotted #ccc}
	ul.errors li {margin:0;padding:2px;list-style:square}
	form th {padding-left:3px;padding-top:2px; background:#e0e0e0;font-weight:normal}
	form th.required {background:#ffffc0}'
! !

!SGLibrary methodsFor: 'other' stamp: 'obi 11/07/2008 13:52'!
notUsedCss
	^'	.page .contents td a {-moz-border-radius: 5px;-webkit-border-radius:5px;border-radius:5px;text-decoration:none;background:#888;border:1px solid #666;padding:0px 4px 0px 4px;color:white;white-space:nowrap}
	.page .contents td a:hover {background:#aaa}'
! !

!SGLibrary methodsFor: 'other' stamp: 'obi 10/31/2008 12:09'!
selectorsToInclude
	^ #(#adminCss #magritteCss)
! !

MARelationDescription subclass: #SGTwowayRelationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 05/12/2009 10:58'!
defaultComponentClasses
	^ Array with: SGTwowayRelationComponent! !

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 04/21/2009 12:58'!
defaultDefault
	^OrderedCollection new
"	^SGTwowayRelation new"! !

!SGTwowayRelationDescription class methodsFor: 'accessing-description' stamp: 'obi 04/19/2009 10:57'!
descriptionClasses
	^ MAMultipleOptionDescription new
		accessor: #classes;
		label: 'Classes';
		priority: 400;
		options: [ SGModel allSubclasses ] asDynamicObject;
		reference: MAClassDescription new;
		yourself! !

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 04/19/2009 11:04'!
isAbstract
	^ false! !

!SGTwowayRelationDescription class methodsFor: 'accessing' stamp: 'obi 04/19/2009 11:03'!
label
	^ 'Twoway Relation'! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/20/2009 11:40'!
isDefinitive
	^false! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/20/2009 11:37'!
isOrdered
	^true! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/20/2009 11:37'!
isSorted
	^false! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 05/12/2009 12:32'!
kind
	^ Collection! !

!SGTwowayRelationDescription methodsFor: 'accessors' stamp: 'obi 04/22/2009 13:40'!
selectorAccessor: aSelector
	"Use SGTwowayRelationAccessor instead of default one"

	self accessor: (SGTwowayRelationAccessor selector: aSelector)! !

!SGTwowayRelationDescription methodsFor: 'accessing' stamp: 'obi 04/22/2009 13:35'!
targetSelector
	^self accessor targetSelector! !

!SGTwowayRelationDescription methodsFor: 'updating' stamp: 'obi 04/21/2009 13:20'!
targetSelector: aSymbol
	"the accessor must be set before"
	self accessor targetSelector: aSymbol! !

!SGTwowayRelationDescription methodsFor: 'method-creation' stamp: 'obi 05/05/2009 13:00'!
updatingMethods
	| newLine sourceString sourceString2 var |
	newLine := Character lf asString.
	var := self accessor readSelector asString.
	sourceString := String new.
	sourceString add: var , 'Add: aModel', newLine , newLine.
	sourceString add: '	(self accessorFor: #' , var , ') write: aModel to: self'.
	sourceString2 := String new.
	sourceString2 add: var , 'Remove: aModel', newLine , newLine.
	sourceString2 add: '	(self accessorFor: #' , var , ') remove: aModel from: self'.
	^Array with: sourceString with: sourceString2! !

MAContainerComponent subclass: #SGContainerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Seaside'!

!SGContainerComponent methodsFor: 'as yet unclassified' stamp: 'YanniChiu 9/29/2009 11:58'!
commit
	super commit.
	self model save! !

MASelectorAccessor subclass: #SGTwowayRelationAccessor
	instanceVariableNames: 'targetSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scaffolding-Base'!

!SGTwowayRelationAccessor class methodsFor: 'accessing' stamp: 'obi 05/05/2009 13:27'!
relationClass
	^OrderedCollection! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/12/2009 13:08'!
add: anObject to: aModel
	| aColl |
	aColl := aModel perform: self readSelector.
	aColl isNil ifTrue: [super write: (aColl := self class relationClass new) to: aModel].
	(aColl includes: anObject)
		ifFalse: [
			aColl add: anObject.
			(anObject perform: targetSelector) add: aModel]
	
	
	! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/16/2009 12:24'!
addAll: aCollection to: aModel
	aCollection do: [:each | self add: each to: aModel]
	! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/05/2009 13:39'!
remove: anObject from: aModel
	"remove the objects from both collections"
	(aModel perform: self readSelector) remove: anObject ifAbsent: [].
	(anObject perform: targetSelector) remove: aModel ifAbsent: []! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/05/2009 13:30'!
removeAllFrom: aModel
	(aModel perform: readSelector) do: [:each | self remove: each from: aModel]! !

!SGTwowayRelationAccessor methodsFor: 'accessing' stamp: 'obi 04/21/2009 13:28'!
targetSelector 
	^targetSelector ! !

!SGTwowayRelationAccessor methodsFor: 'accessing' stamp: 'obi 04/21/2009 13:27'!
targetSelector: aSymbol
	targetSelector := aSymbol! !

!SGTwowayRelationAccessor methodsFor: 'model' stamp: 'obi 05/24/2009 10:32'!
write: anObject to: aModel
	| aColl |
	"add anObject to my collection and also add aModel to the other object collection 2"
	anObject ifNil: [^self removeAllFrom: aModel].
	(anObject isKindOf: Collection)
		ifTrue: [super write: anObject to: aModel]
		ifFalse: [self add: anObject to: aModel]! !
SGModel initialize!
SGAdmin initialize!
SGLogin initialize!
